# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python or TypeScript SDK.  To install the official [Python SDK](https://pypi.org/project/humanloop/), run the following command:  ```bash pip install humanloop ```  To install the official [TypeScript SDK](https://www.npmjs.com/package/humanloop), run the following command:  ```bash npm i humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://docs.humanloop.com/).

    The version of the OpenAPI document: 4.0.0
    Generated by: https://konfigthis.com
"""

from datetime import datetime, date
import typing
from enum import Enum
from typing_extensions import TypedDict, Literal

from humanloop.type.chat_data_response import ChatDataResponse
from humanloop.type.chat_response_provider_responses import ChatResponseProviderResponses
from humanloop.type.usage import Usage

class RequiredChatResponse(TypedDict):
    # Array containing the chat responses.
    data: typing.List[ChatDataResponse]

    provider_responses: ChatResponseProviderResponses

class OptionalChatResponse(TypedDict, total=False):
    # Unique identifier of the parent project. Will not be provided if the request was made without providing a project name or id
    project_id: str

    # The number of chat responses.
    num_samples: int

    # Include the log probabilities of the top n tokens in the provider_response
    logprobs: int

    # The suffix that comes after a completion of inserted text. Useful for completions that act like inserts.
    suffix: str

    # End-user ID passed through to provider call.
    user: str

    # Counts of the number of tokens used and related stats.
    usage: Usage

    # Any additional metadata to record.
    metadata: typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]

class ChatResponse(RequiredChatResponse, OptionalChatResponse):
    pass
